#include "stdafx.h"
#include "../ArchiverCode/arc_interface.h"
#include "configwnd.h"
#include "../Utilities/OSUtil.h"


CConfigDialog::CConfigDialog(CConfigManager &cfg)
	:mr_Config(cfg),
	hActiveDialogWnd(NULL),
	PageShellExt(*this),
	PageAssociation(*this),
	m_nAssistRequireCount(0)
{
	TRACE(_T("CConfigDialog()\n"));

	//e|INIt@C擾
	TCHAR szIniName[_MAX_PATH+1]={0};
	UtilGetTemporaryFileName(szIniName,_T("lhf"));
	m_strAssistINI=szIniName;

	//ݒǂݍ
	CString strErr;
	if(!mr_Config.LoadConfig(strErr))ErrorMessage(strErr);
}

CConfigDialog::~CConfigDialog()
{
}


LRESULT CConfigDialog::OnInitDialog(HWND hWnd, LPARAM lParam)
{
	// 傫ACRݒ
	HICON hIcon = AtlLoadIconImage(IDI_APP, LR_DEFAULTCOLOR,::GetSystemMetrics(SM_CXICON),::GetSystemMetrics(SM_CYICON));
	SetIcon(hIcon, TRUE);

	// ACRݒ
	HICON hIconSmall = AtlLoadIconImage(IDI_APP, LR_DEFAULTCOLOR,::GetSystemMetrics(SM_CXSMICON), ::GetSystemMetrics(SM_CYSMICON));
	SetIcon(hIconSmall, FALSE);

	//vpeBV[g\t邽߂̃XN[Rei̔zuꏊ擾
	CStatic StaticFrame;
	StaticFrame=GetDlgItem(IDC_STATIC_FRAME);
	RECT rect;
	StaticFrame.GetWindowRect(&rect);
//	StaticFrame.ShowWindow(SW_HIDE);
	ScreenToClient(&rect);

	//XN[Reizu
	ScrollWindow.Create(m_hWnd,rect,NULL,/*WS_TABSTOP|*/WS_CHILD|WS_VISIBLE , WS_EX_CLIENTEDGE|WS_EX_CONTROLPARENT);

	//--------------------
	// c[r[̐ݒ
	//--------------------
	SelectTreeView=GetDlgItem(IDC_TREE_SELECT_PROPPAGE);

#define ADD_PAGE(_DIALOG,_ROOTITEM) {\
	m_ConfigDlgList.insert(&_DIALOG);\
	_DIALOG.LoadConfig(mr_Config);\
	_DIALOG.Create(ScrollWindow);\
	CString strTitle;\
	_DIALOG.GetWindowText(strTitle);\
	HTREEITEM hItem=SelectTreeView.InsertItem(strTitle, _ROOTITEM, TVI_LAST);\
	SelectTreeView.SetItemData(hItem,(DWORD_PTR)_DIALOG.m_hWnd);\
}

	//--------------------------------
	// _CAȌǉĂ
	//--------------------------------
	ADD_PAGE(PageGeneral,TVI_ROOT);
	ADD_PAGE(PageShellExt,TVI_ROOT);
	ADD_PAGE(PageShortcut,TVI_ROOT);
	ADD_PAGE(PageFileListWindow,TVI_ROOT);
	ADD_PAGE(PageCompressGeneral,TVI_ROOT);
	ADD_PAGE(PageExtractGeneral,TVI_ROOT);
	ADD_PAGE(PageAssociation,TVI_ROOT);
	ADD_PAGE(PageOpenAction,TVI_ROOT);
//	ADD_PAGE(PageAssociation2,TVI_ROOT);
	ADD_PAGE(PageDLLUpdate,TVI_ROOT);
	ADD_PAGE(PageVersion,TVI_ROOT);

	//----------------
	// ȉ͏ڍאݒ
	//----------------
	//c[̐e
	m_ConfigDlgList.insert(&PageDetail);
	PageDetail.LoadConfig(mr_Config);
	PageDetail.Create(ScrollWindow);
	HTREEITEM hItemDetail;
	{
		TCHAR Buffer[_MAX_PATH+1]={0};
		PageDetail.GetWindowText(Buffer,_MAX_PATH);
		hItemDetail=SelectTreeView.InsertItem(Buffer, TVI_ROOT, TVI_LAST);
	}
	SelectTreeView.SetItemData(hItemDetail,(DWORD_PTR)PageDetail.m_hWnd);

	ADD_PAGE(PageLZH,hItemDetail);
	ADD_PAGE(PageZIP,hItemDetail);
	ADD_PAGE(PageCAB,hItemDetail);
	ADD_PAGE(Page7Z,hItemDetail);
	ADD_PAGE(PageTAR,hItemDetail);
	ADD_PAGE(PageJACK,hItemDetail);
//	ADD_PAGE(PageBH,hItemDetail);
//	ADD_PAGE(PageYZ1,TVI_ROOT);
	ADD_PAGE(PageHKI,hItemDetail);
	ADD_PAGE(PageBGA,hItemDetail);
	ADD_PAGE(PageAISH,hItemDetail);
	ADD_PAGE(PageXACRETT,hItemDetail);
	ADD_PAGE(PageB2E,hItemDetail);
	ADD_PAGE(PageDLL,hItemDetail);

	//------------------------
	// ͂߂ɕ\y[W
	//------------------------
	PageGeneral.ShowWindow(SW_SHOW);
	ScrollWindow.SetClient(PageGeneral);
	hActiveDialogWnd=PageGeneral;
	SelectTreeView.SetFocus();

	// _CAOTCY
	DlgResize_Init(true, true, WS_THICKFRAME | WS_CLIPCHILDREN);

	//---[U[ԋʐݒ?
	if(mr_Config.IsUserCommon()){
		//EBhE^Cgݒ
		SetWindowText(CString(MAKEINTRESOURCE(IDS_CAPTION_CONFIG_USERCOMMON)));
	}

	//EBhE𒆐S
	CenterWindow();

	return TRUE;
}

void CConfigDialog::OnOK(UINT uNotifyCode, int nID, HWND hWndCtl)
{
	//OɃj[GfB^ȂǂŐݒ肪ύXĂꍇAŒPɏ㏑ƁAύX̏񂪏Ă܂̂
	//ēǂݍ݂sAɏ㏑
	CString tmp;
	mr_Config.LoadConfig(tmp);

	//e_CAOOnApplyĂ
	bool bRet=true;
	for(std::set<IConfigDlgBase*>::iterator ite=m_ConfigDlgList.begin();ite!=m_ConfigDlgList.end();++ite){
		bRet=bRet && (*ite)->OnApply();
		(*ite)->StoreConfig(mr_Config);
	}

	//UAC̃AVX^gvĂ
	if(m_nAssistRequireCount>0){
		//64bitȂ64bitpɑ点
		if(UtilIsWow64()){
			//LFAssist(64bit)ɏnBINI폜͍sȂB
			//---AVX^g(64bit)̃pX擾
			CPath strExePath(UtilGetModuleDirectoryPath());
			strExePath+=_T("LFAssist64.exe");
			if(strExePath.FileExists()){	//t@C݂Ƃ̂
				strExePath.QuoteSpaces();

				//---s:CreateProcessłUAC`FbNĎsĂ炦Ȃ
				SHELLEXECUTEINFO shei={0};
				shei.fMask=SEE_MASK_FLAG_DDEWAIT;	//uɏI\̂łw肷
				shei.cbSize=sizeof(shei);
				shei.lpFile=strExePath;
				shei.lpParameters=m_strAssistINI;
				shei.nShow=SW_SHOW;
				if(!ShellExecuteEx(&shei)){
					//sG[
					CString strLastError;
					UtilGetLastErrorMessage(strLastError);

					CString msg;
					msg.Format(IDS_ERROR_CANNOT_EXECUTE,strExePath,(LPCTSTR)strLastError);

					ErrorMessage(msg);
				}
			}
		}

		//LFAssist(32bit)INI폜v
		WritePrivateProfileString(_T("PostProcess"),_T("DeleteMe"),_T("Please_Delete_Me"),m_strAssistINI);

		//ύXs
		//---AVX^g̃pX擾
		CPath strExePath(UtilGetModuleDirectoryPath());
		strExePath+=_T("LFAssist.exe");
		strExePath.QuoteSpaces();

		//---s:CreateProcessłUAC`FbNĎsĂ炦Ȃ
		SHELLEXECUTEINFO shei={0};
		shei.fMask=SEE_MASK_FLAG_DDEWAIT;	//uɏI\̂łw肷
		shei.cbSize=sizeof(shei);
		shei.lpFile=strExePath;
		shei.lpParameters=m_strAssistINI;
		shei.nShow=SW_SHOW;
		if(!ShellExecuteEx(&shei)){
			//sG[
			CString strLastError;
			UtilGetLastErrorMessage(strLastError);

			CString msg;
			msg.Format(IDS_ERROR_CANNOT_EXECUTE,strExePath,(LPCTSTR)strLastError);

			ErrorMessage(msg);
		}else{
			Sleep(100);
			::SHChangeNotify(SHCNE_ASSOCCHANGED,SHCNF_FLUSH,NULL,NULL);	//֘At̕ύXVFɒʒm(ύXĂȂȂȕւ̂)
		}
	}else{
		//e|INI폜
		if(!m_strAssistINI.IsEmpty()){
			::DeleteFile(m_strAssistINI);
		}
	}

	if(bRet)EndDialog(nID);
}

void CConfigDialog::OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl)
{
	EndDialog(nID);
}

LRESULT CConfigDialog::OnTreeSelect(LPNMHDR pnmh)
{
	if(pnmh->hwndFrom==SelectTreeView){
		HTREEITEM hItem=SelectTreeView.GetSelectedItem();
		if(!hItem)return 0;

		HWND hSelectedDialogWnd=(HWND)SelectTreeView.GetItemData(hItem);
		if(NULL!=hSelectedDialogWnd && hSelectedDialogWnd!=hActiveDialogWnd){
			::ShowWindow(hActiveDialogWnd,SW_HIDE);
			::ShowWindow(hSelectedDialogWnd,SW_SHOW);
			ScrollWindow.SetClient(NULL);
			ScrollWindow.SetClient(hSelectedDialogWnd);
			hActiveDialogWnd=hSelectedDialogWnd;
		}
	}
	return 0;
}

void CConfigDialog::OnSize(UINT, CSize&)
{
	SetMsgHandled(false);
	PostMessage(WM_USER_WM_SIZE);
}

LRESULT CConfigDialog::OnUserSize(UINT, WPARAM, LPARAM, BOOL& bHandled)
{
	//vpeBV[g\t邽߂̃XN[Rei̔zuꏊ擾
	CStatic StaticFrame;
	StaticFrame=GetDlgItem(IDC_STATIC_FRAME);
	RECT rect;
	StaticFrame.GetWindowRect(&rect);
	ScreenToClient(&rect);

	//XN[Reiړ
	ScrollWindow.MoveWindow(&rect);
	return 0;
}

//LFAssist.exe̗vJEg𑀍
void CConfigDialog::RequireAssistant()
{
	m_nAssistRequireCount++;
	Button_SetElevationRequiredState(GetDlgItem(IDOK),m_nAssistRequireCount);
}

void CConfigDialog::UnrequireAssistant()
{
	ASSERT(m_nAssistRequireCount>0);
	if(m_nAssistRequireCount>0){
		m_nAssistRequireCount--;
		Button_SetElevationRequiredState(GetDlgItem(IDOK),m_nAssistRequireCount);
	}
}
