#pragma once
#include "../Utilities/Utility.h"
#include "../resource.h"
#include "ConfigManager.h"
#include "./Dialogs/Dlg_Base.h"
#include "./Dialogs/Dlg_version.h"
#include "./Dialogs/Dlg_general.h"
#include "./Dialogs/Dlg_compress_general.h"
#include "./Dialogs/Dlg_extract_general.h"
#include "./Dialogs/Dlg_lzh.h"
#include "./Dialogs/Dlg_zip.h"
#include "./Dialogs/Dlg_cab.h"
#include "./Dialogs/Dlg_7z.h"
#include "./Dialogs/Dlg_tar.h"
#include "./Dialogs/Dlg_jack.h"
#include "./Dialogs/Dlg_hki.h"
#include "./Dialogs/Dlg_bga.h"
#include "./Dialogs/Dlg_aish.h"
#include "./Dialogs/Dlg_xacrett.h"
#include "./Dialogs/Dlg_b2e.h"
#include "./Dialogs/Dlg_dll_update.h"
#include "./Dialogs/Dlg_assoc.h"
#include "./Dialogs/Dlg_detail.h"
#include "./Dialogs/Dlg_shortcut.h"
#include "./Dialogs/Dlg_filelistwindow.h"
#include "./Dialogs/Dlg_openaction.h"
#include "./Dialogs/Dlg_shellext.h"
#include "./Dialogs/Dlg_DLL.h"

//====================================
// ݒ荀ڂ܂Ƃ߂
//====================================
class CConfigDialog : public CDialogImpl<CConfigDialog>,public CDialogResize<CConfigDialog>
{
protected:
	CConfigDlgGeneral				PageGeneral;
	CConfigDlgShellExt				PageShellExt;
	CConfigDlgVersion				PageVersion;
	CConfigDlgCompressGeneral		PageCompressGeneral;
	CConfigDlgExtractGeneral		PageExtractGeneral;
	CConfigDlgLZH					PageLZH;
	CConfigDlgZIP					PageZIP;
	CConfigDlgCAB					PageCAB;
	CConfigDlg7Z					Page7Z;
	CConfigDlgTAR					PageTAR;
	CConfigDlgJACK					PageJACK;
	CConfigDlgHKI					PageHKI;
	CConfigDlgBGA					PageBGA;
	CConfigDlgAISH					PageAISH;
	CConfigDlgXACRETT				PageXACRETT;
	CConfigDlgB2E					PageB2E;
	CConfigDlgDLLUpdate				PageDLLUpdate;
	CConfigDlgAssociation			PageAssociation;
	CConfigDlgOpenAction			PageOpenAction;
	CConfigDlgDetail				PageDetail;
	CConfigDlgShortcut				PageShortcut;
	CConfigDlgFileListWindow		PageFileListWindow;
	CConfigDlgDLL					PageDLL;

	HWND						hActiveDialogWnd;	//ANeBuȃ_CAO
	CTreeViewCtrl				SelectTreeView;

	//_CAO\t邽߂̃XN[Rei
	CScrollContainer			ScrollWindow;

	CConfigManager				&mr_Config;

	CString						m_strAssistINI;	//AVX^gĂяo߂ɎgINI
	UINT						m_nAssistRequireCount;//AVX^gĂԕKvΔ0;QƃJE^


	std::set<IConfigDlgBase*> m_ConfigDlgList;
public:
	enum{IDD = IDD_DIALOG_CONFIG};

	// bZ[W}bv
	BEGIN_MSG_MAP_EX(CConfigDialog)
		MSG_WM_INITDIALOG(OnInitDialog)
		NOTIFY_CODE_HANDLER_EX(TVN_SELCHANGED, OnTreeSelect)
		COMMAND_ID_HANDLER_EX(IDOK, OnOK)
		COMMAND_ID_HANDLER_EX(IDCANCEL, OnCancel)
		MSG_WM_SIZE(OnSize)
		CHAIN_MSG_MAP(CDialogResize<CConfigDialog>)
		MESSAGE_HANDLER(WM_USER_WM_SIZE,OnUserSize)
	END_MSG_MAP()

	// _CAOTCY}bv
	BEGIN_DLGRESIZE_MAP(CConfigDialog)
		DLGRESIZE_CONTROL(IDC_TREE_SELECT_PROPPAGE,			DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDC_STATIC_FRAME,					DLSZ_SIZE_X | DLSZ_SIZE_Y)
		DLGRESIZE_CONTROL(IDOK,								DLSZ_MOVE_X | DLSZ_MOVE_Y)
		DLGRESIZE_CONTROL(IDCANCEL,							DLSZ_MOVE_X | DLSZ_MOVE_Y)
	END_DLGRESIZE_MAP()

	CConfigDialog(CConfigManager &cfg);
	virtual ~CConfigDialog();

	LRESULT OnTreeSelect(LPNMHDR pnmh);
	LRESULT OnInitDialog(HWND hWnd, LPARAM lParam);
	void OnSize(UINT, CSize&);
	LRESULT OnUserSize(UINT, WPARAM wParam, LPARAM, BOOL& bHandled);

	void OnOK(UINT uNotifyCode, int nID, HWND hWndCtl);
	void OnCancel(UINT uNotifyCode, int nID, HWND hWndCtl);

	//LFAssist.exeɓnINI̖O(UAĈ)
	LPCTSTR GetAssistantFile(){return m_strAssistINI;}
	//UAĈLFAssist.exeĂԂƂv(vJEg𑝂₷)
	void RequireAssistant();
	//UAĈLFAssist.exeĂԂƂ߂(vJEg炷)
	void UnrequireAssistant();
};

