#pragma once
#include "../ArchiverCode/ArcEntryInfo.h"
#include "../ConfigCode/ConfigManager.h"
#include "../Utilities/PtrCollection.h"

struct IArchiveContentUpdateHandler{
	virtual ~IArchiveContentUpdateHandler(){}
	virtual void onUpdated(ARCHIVE_ENTRY_INFO&)=0;
	virtual bool isAborted()=0;
};


/*
 * A[JCũt@C\ێ
 */
class CArchiverDLL;
enum DLL_ID;
class CArchiveFileContent{
protected:
	//t@C
	ARCHIVE_ENTRY_INFO_TREE m_Root;
	bool m_bValid;	//Ȃtrue

	//Semi-Auto Garbage Collector
	CSmartPtrCollection<ARCHIVE_ENTRY_INFO> m_GC;

	CArchiverDLL*	m_lpArchiver;
	CString			m_pathArcFileName;
	bool			m_bExtractEachSupported;
protected:
	//---internal functions
	ARCHIVE_ENTRY_INFO_TREE* ForceFindEntry(ARCHIVE_ENTRY_INFO_TREE* lpParent,LPCTSTR lpName);

	//bMatchPath:trueȂpX܂ߌAfalseȂt@Ĉ݌
	void FindSubItem(LPCTSTR lpszMask,bool bMatchPath,const ARCHIVE_ENTRY_INFO_TREE *lpTop,std::vector<ARCHIVE_ENTRY_INFO_TREE*> &founds)const;

	void PostProcess(bool bUnicode,ARCHIVE_ENTRY_INFO_TREE*);
	HRESULT InspectArchiveStruct(LPCTSTR lpFile,CConfigManager&,CArchiverDLL*,std::vector<ARCHIVE_ENTRY_INFO>&,IArchiveContentUpdateHandler*);

public:
	CArchiveFileContent();
	virtual ~CArchiveFileContent();

	//ΏۃA[JCu擾
	void SetArchiveFileName(LPCTSTR lpFile){m_pathArcFileName=lpFile;}
	LPCTSTR GetArchiveFileName()const{return m_pathArcFileName;}
	const CArchiverDLL* GetArchiver()const{return m_lpArchiver;}

	ARCHIVE_ENTRY_INFO_TREE* GetRootNode(){return &m_Root;}
	const ARCHIVE_ENTRY_INFO_TREE* GetRootNode()const{return &m_Root;}

	HRESULT ConstructFlat(LPCTSTR lpFile,CConfigManager&,DLL_ID idForce,LPCTSTR lpDenyExt,bool bFilesOnly,CString &strErr,IArchiveContentUpdateHandler*);
	HRESULT ConstructTree(LPCTSTR lpFile,CConfigManager&,DLL_ID idForce,LPCTSTR lpDenyExt,bool bSkipMeaningless,CString &strErr,IArchiveContentUpdateHandler*);
	void Clear();

	bool ReloadArchiverIfLost(CConfigManager &ConfigManager,CString &strErr);

	bool IsExtractEachSupported()const{return m_bExtractEachSupported;}
	bool IsDeleteItemsSupported()const;
	bool IsAddItemsSupported()const;
	bool IsUnicodeCapable()const;
	BOOL CheckArchiveExists()const{return PathFileExists(m_pathArcFileName);}

	//lpTopȉ̃t@C
	void FindItem(LPCTSTR lpszMask,const ARCHIVE_ENTRY_INFO_TREE *lpTop,std::vector<ARCHIVE_ENTRY_INFO_TREE*> &founds)const;

	HRESULT AddItem(const std::list<CString>&,LPCTSTR lpDestDir,CConfigManager& rConfig,CString&);	//t@Cǉk
	bool ExtractItems(CConfigManager&,const std::list<ARCHIVE_ENTRY_INFO_TREE*> &items,LPCTSTR lpszDir,const ARCHIVE_ENTRY_INFO_TREE* lpBase,bool bCollapseDir,CString &strLog);
	//bOverwrite:trueȂ瑶݂e|t@C폜Ă𓀂
	bool MakeSureItemsExtracted(CConfigManager&,LPCTSTR lpOutputDir,const ARCHIVE_ENTRY_INFO_TREE* lpBase,const std::list<ARCHIVE_ENTRY_INFO_TREE*> &items,std::list<CString> &r_filesList,bool bOverwrite,CString &strLog);
	bool DeleteItems(CConfigManager&,const std::list<ARCHIVE_ENTRY_INFO_TREE*>&,CString&);
};
